"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServerList = void 0;
const server_1 = require("./server");
const rp = require('request-promise');
const cheerio_1 = require("cheerio");
const DEFAULT_URL = 'https://www.vpngate.net';
const TABLE_ID = 'vg_hosts_table_id';
const TABLE_HEADER_FIRST_HEADER_COLUMN = 'Country';
let $;
let hostsTable;
const rows = [];
const hosts = [];
const extractHosts = () => {
    for (let row of rows) {
        hosts.push(new server_1.Server(row));
    }
    return hosts;
};
const extractRows = () => {
    let rowContainer = hostsTable.children(`tbody`).children(`tr`);
    let tempRowKeep;
    for (let i = 0; i < rowContainer.length; i++) {
        tempRowKeep = rowContainer.eq(i);
        if (tempRowKeep.children('td').children('b').html() !== TABLE_HEADER_FIRST_HEADER_COLUMN)
            rows.push(tempRowKeep);
    }
    return extractHosts();
};
const extractTable = () => {
    hostsTable = $(`#${TABLE_ID}`).last();
    return extractRows();
};
const loadRoot = (html) => {
    $ = (0, cheerio_1.load)(html);
    return extractTable();
};
// TODO: Publish the NPM
function ServerList(url = DEFAULT_URL) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve, reject) => {
            rp(url)
                .then((html) => resolve(loadRoot(html)))
                .catch((err) => reject('Error occurred on requesting the HTML from URL:\n' + err));
        });
    });
}
exports.ServerList = ServerList;
