import { Server } from "./server";
const rp = require('request-promise');
import { load } from "cheerio";
const DEFAULT_URL = 'https://www.vpngate.net';
const TABLE_ID = 'vg_hosts_table_id';
const TABLE_HEADER_FIRST_HEADER_COLUMN = 'Country';
let $;
let hostsTable;
const rows = [];
const hosts = [];
const extractHosts = () => {
    for (let row of rows) {
        hosts.push(new Server(row));
    }
    return hosts;
};
const extractRows = () => {
    let rowContainer = hostsTable.children(`tbody`).children(`tr`);
    let tempRowKeep;
    for (let i = 0; i < rowContainer.length; i++) {
        tempRowKeep = rowContainer.eq(i);
        if (tempRowKeep.children('td').children('b').html() !== TABLE_HEADER_FIRST_HEADER_COLUMN)
            rows.push(tempRowKeep);
    }
    return extractHosts();
};
const extractTable = () => {
    hostsTable = $(`#${TABLE_ID}`).last();
    return extractRows();
};
const loadRoot = (html) => {
    $ = load(html);
    return extractTable();
};
// TODO: Publish the NPM
export async function ServerList(url = DEFAULT_URL) {
    return new Promise((resolve, reject) => {
        rp(url)
            .then((html) => resolve(loadRoot(html)))
            .catch((err) => reject('Error occurred on requesting the HTML from URL:\n' + err));
    });
}
